import React from 'react';
import {
  connect
} from 'react-redux';
import Inspect from '@components/Inspect';
import {
  getSearchList,
  getSublableList,
} from '@store/async-actions/inspect';
import {
  setLabel,
  fillActived,
  fillActiveDetail,
  checkValueIsChange,
  delExcelLis,
  clearLabel,
  delPartItem,
  setContext,
  setTip
} from '@store/actions/inspect';
import {
  billing,
  getConceptDetail,
  getMRAnalyse
} from '@store/async-actions/pushMessage';
import {HIDEDROP} from '@types/homePage';

function mapStateToProps(state) {//console.log(state)
  return {
    list: state.inspect.list,
    labelList: state.inspect.labelList,
    fillActive: state.inspect.fillActive,
    getExcelDataList: state.inspect.getExcelDataList,
    labelListActive: state.inspect.labelListActive,
    inspectList: state.homePage.inspectList,
    windowHeight: state.homePage.windowHeight,
    windowWidth: state.homePage.windowWidth,
    inspectVal: state.inspect.inspectVal,
    message: state.patInfo.message,
    hospitalMsg: state.homePage.sysConfig || {},
    typeConfig: state.typeConfig
  }
}

function mapDispatchToProps(dispatch, store) {
  return {
    setContext(obj){
      dispatch(setContext(obj))
    },
    handleChangeValue(val) {
      dispatch(getSearchList(val))
    },
    getInfomation(item) {
      dispatch(getConceptDetail(item))
    },
    handleSign(id, idx, type) {
      dispatch(setLabel(idx, type))
      dispatch(getSublableList(id))
      dispatch(getMRAnalyse())
    },
    handleLabelSub(e, id, idx) {
      dispatch(fillActived(id, idx))
      // e.stopPropagation()
    },
    handleClear(e, idx) {
      e.stopPropagation();
      dispatch(clearLabel(idx))
    },
    handleConfirm(e, idx, time, arr) {
      e.stopPropagation();
      dispatch(checkValueIsChange(idx, time, arr))
    },
    changeActivePart(idx, value) {
      dispatch(fillActiveDetail(idx, value))
    },
    handleCloseExcel(idx) {
      dispatch(delExcelLis(idx));
      dispatch(getMRAnalyse())
    },
    delPartItem(idx) {
      dispatch(delPartItem(idx))
      dispatch(getMRAnalyse())
    },
    setTipValue(idx,value) {
      dispatch(setTip(idx,value))
    },
    //右侧推送
    fetchPushInfos() {
      //调右侧推送
      dispatch(billing());
    },
    hideAllDrop(){
      dispatch({
        type:HIDEDROP
      });
    },
  }
}

const InspectAction = connect(mapStateToProps, mapDispatchToProps)(Inspect);

export default InspectAction;